
function size(){}
size.prototype.offset = 0;
size.prototype.length = 0;
size.prototype.copies = 0;
size.prototype.nofuzz = 0;
size.prototype.data = "";
size.prototype.valueSetterFn = null;

size.create = function(offset, length, copies, nofuzz, valueSetterFn, sizeId){
  var sizeObj = new size();
  sizeObj.offset = offset;
  sizeObj.length = length;
  sizeObj.copies = copies;
  sizeObj.nofuzz = nofuzz || false;
  sizeObj.data = fontData.substr(offset, length);
  sizeObj.valueSetterFn = valueSetterFn || null;
  if(sizeId)
    sizeIds[sizeId] = sizeObj;
    
  return sizeObj;
}

function structure(){}
structure.prototype.sizes = null;
structure.prototype.file_length = 0;
structure.prototype.tables = {};
structure.prototype.currTable = null;

structure.create = function(length)
{
  var structObj = new structure();
  structObj.file_length = length;
  
  return structObj;
}

structure.prototype.add = function(length, nofuzz, canChangeLength, valueSetterFn, sizeId)
{
  var s;
  if(this.sizes == null)
  {
    this.sizes = [];
    s = size.create(0, length, 1, nofuzz, valueSetterFn, sizeId);
    this.sizes.push(s);
    this.offset = length;
  }
  else
  {
    //var offset = this.sizes[this.sizes.length - 1].offset +
    //             this.sizes[this.sizes.length - 1].length;
    
    //todo: i dont think the block at line 114 is necessary, but is it?
    s = size.create(this.offset, length, 1, nofuzz, valueSetterFn, sizeId);
    this.sizes.push(s);
    this.offset += length;
  }
  
  if(this.currTable)
  {
    if(!this.tables[this.currTable])
      this.tables[this.currTable] = [];
    
    this.tables[this.currTable].push(s);
  }
         
  return length;
}

structure.prototype.add_offset = function(offset, length, nofuzz)
{
  if(this.sizes == null)
  {
    this.add(offset, true);
    this.add(length, nofuzz);
  }
  else
  {
    var sz = this.sizes[this.sizes.length - 1];
    var gap = offset - (sz.offset + sz.length);
    if(gap && gap < offset)
      this.add(gap, 1);
    this.add(length, nofuzz);
  }
}

structure.prototype.set_collapse_fn = function(fn)
{
  this.collapse_fn = fn;
}

structure.prototype.generic = function(length)
{
  var struct = structure.create(length);
  var used = 0;
  while(used < length)
  {
    var next = 1 << rand_range(1, 10);
    if(used + next > length)
      next = length - used;
    this.add(next, 0);
  }
  
  return struct;
}


function tableHeader(){}
tableHeader.prototype.tag = "";
tableHeader.prototype.checksum = 0;
tableHeader.prototype.offset = 0;
tableHeader.prototype.length = 0;
tableHeader.prototype.headerOffset = 0;
tableHeader.prototype.checksumField = null;

tableHeader.create = function(data, struct)
{

  var th = new tableHeader();
  
  th.tag = data.substr(struct.offset, 4);
  th.checksum = getMBInt(LONG, data, struct.offset+4)
  th.offset = getMBInt(LONG, data, struct.offset+8);
  th.length = getMBInt(LONG, data, struct.offset+12);
  th.headerOffset = struct.offset;
  
  struct.add(ULONG, true); //tag
  struct.add(ULONG, true); //checksum
  th.checksumField = struct.sizes[struct.sizes.length - 1];
  //todo: change the following in post-processing if necessary
  struct.add(ULONG); //offset
  struct.add(ULONG); //length
  
  
  return th;
}